#!/bin/bash

#IPNET=192.168.1
IPNET=172.17.11
#MAC_PATTERN="70:82:0e:99:9"
MAC_PATTERN="70:82:0e:"

ROT="\033[36;1;31m"
GRUEN="\033[36;1;32m"
BLAU="\033[36;1;34m"
SCHWARZ="\033[36;0;30m"
WEISS="\033[36;0m"

###############################################################################
# Funktionen
###############################################################################
function print_error ()
{
	echo -e "	$ROT$1$WEISS"
	exit -1
}

function print_warning ()
{
	echo -e "	$ROT$1$WEISS"
}

function check_file()
{
	if [ -f $1 ];
	then
		echo "	$2 (Datei $1) gefunden"
	else
		print_error "$2 (Datei $1) nicht gefunden"
	fi
}

###############################################################################
date1=$(date +"%s")

if [ -z $1 ]; then
	start=1
else
	start=$1
fi

if [ -z $2 ]; then
	end=255
else
	end=$2
fi


echo "Scanne Bereich $IPNET.$start to $IPNET.$end ..."

trap 'echo "Aborting scanning ...";exit 1' INT

for ip in $(seq $start $end); do
	fping -q -c 1 -t 50 $IPNET.$ip >/dev/null 2>&1
	if [ $? -eq 0 ] ; then
		arptxt=$(arp -n $IPNET.$ip | grep ether)
		if [ "$(echo "$arptxt" | grep -i $MAC_PATTERN)" != "" ] ; then
			print_warning "Geraet gefunden: $arptxt"
#			break
		else
			echo "$IPNET.$ip UP: $arptxt"	
		fi
	else
		echo -e "$IPNET.$ip DOWN"	
		echo -e "\033[2A"	
	fi
done


date2=$(date +"%s")
diff=$((date2-$date1))
echo -e -n $BLAU
echo -e "Scanzeit: $diff Sekunde(n)"
echo -e -n $WEISS


