
import subprocess
import os
from output import vinfo

##
## @brief git command simple wrapper
##
## @details use cwd in kwargs to move from one repo to another


def git_cmd(cmd, display=False, **kwargs):
    if not "git" in cmd[0]:
        cmd.insert(0, "git")
    env = os.environ.copy()
    if not 'stdout' in kwargs:
        kwargs['stdout'] = subprocess.PIPE
    if not 'stderr' in kwargs:
        kwargs['stderr'] = subprocess.PIPE
    kwargs['env'] = env
    ret = subprocess.Popen(cmd, **kwargs)
    out, err = ret.communicate()
    ret.stdout = out
    ret.stderr = err

    if display:
        vinfo('Running command : %s' % " ".join(cmd))

    if ret.returncode != 0:
        raise Exception('Command failed: %s:\n%s' % (" ".join(cmd), ret.stderr))
    return ret

