#!/bin/bash

source $(dirname $0)/print.sh


function print_usage
{
	echo "Usage:"
	filename=$(basename $0)
	echo -e "$filename -h: print help"
	echo -e "$filename [-n] branch1 branch2: show n/all commits between branch1 and branch2"
	echo -e "$filename [-n] branch: show n/all commits of branch"
	echo -e "$filename: show last 10 commits of branch master"
	exit 0
}

# main

count=0
case $1 in
    -h)
		print_usage
    	;;
    -n)
		if [ -z $2 ]; then
			print_usage
		fi
		count="$2"
		shift # past argument
		shift # past argument
    	;;
    *)
        # unknown option
    	;;
esac

if [ -z $2 ]; then
	if [ -z $1 ]; then
		# keine Parameter, gebe $count commits von master aus
		branch1="master"
		branch2=""
		if [ $count -eq 0 ]; then
			count=10
		fi
	else
		branch1=$1
	fi
else
	branch1=$1
	branch2=$2
fi
#echo "branch1=<$branch1>"
#echo "branch2=<$branch2>"



if [ -z $branch2 ]; then
	if [ $count -eq 0 ]; then
		commit_list="$(git log $branch1 --format=%H)"
	else
		commit_list="$(git log $branch1 --format=%H -$count)"
	fi 
	print_info "commits und geaenderte files von <$branch1> ..."
else
	if [ $count=0 ]; then
		commit_list="$(git log $branch1..$branch2 --format=%H)"
	else
		commit_list="$(git log $branch1..$branch2 --format=%H -$count)"
	fi
	print_info "commits und geaenderte files von <$branch1> zu <$branch2> ..."
fi

#echo "commit_list=<$commit_list>"
for commit_id in $commit_list; do
	if [ -t 1 ]; then
		git log $commit_id --format="*************************************************%n%Cgreen%H%Creset%n%cn%n%cd%n%s%n" -1
	else
		git log $commit_id --format="*************************************************%n%H%n%cn%n%cd%n%s%n" -1
	fi
	git diff $commit_id^! --name-status
done


