#!/bin/bash 

 full_dir=$(pwd)
build_dir=$(basename $full_dir)
yml_file="mkdocs.yml"

#define signal handler
trap 'cleanup' 2 

cleanup() { 
	rm $yml_file
}

if [[ "$build_dir" != "build-"* ]];then
	echo "please execute this script from a build- directory. Aborting..."
	exit 1
fi

if [ ! -d docs ];then
	echo "directory docs does not exist. Aborting..."
	exit 1
fi 

mapfile -t MD_ARRAY < <( find docs -name *.md )

echo "site_name: Custom docs" >> $yml_file
echo "docs_dir: 'docs'" >> $yml_file
echo  "site_dir: 'site'" >> $yml_file
echo "theme_dir: '/opt/mkdocs-themes/mkdocs-material-exceet/material'" >> $yml_file
echo "markdown_extensions:" >> $yml_file
 echo "- admonition" >> $yml_file
echo "pages:" >> $yml_file

for element in ${MD_ARRAY[@]}
do 
	md=$(basename $element)
	echo $md
	echo "- '$md': '$md'" >> $yml_file
done

mkdocs serve
